<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Entity;

use DateTimeInterface;
use Doctrine\Common\Collections\Collection;
use Sylius\Component\Channel\Model\ChannelInterface;
use Sylius\Component\Core\Model\CustomerInterface;
use Sylius\Component\Resource\Model\ResourceInterface;

interface QuoteInterface extends ResourceInterface
{
    public function getNumber(): ?string;

    public function setNumber(?string $number): self;

    public function getChannel(): ?ChannelInterface;

    public function setChannel(?ChannelInterface $channel): self;

    public function getCustomer(): ?CustomerInterface;

    public function setCustomer(?CustomerInterface $customer): self;

    public function getItems(): Collection;

    public function setItems(Collection $items): self;

    public function getTotal(): ?int;

    public function setTotal(?int $total): self;

    public function getCurrencyCode(): ?string;

    public function setCurrencyCode(?string $currencyCode): self;

    public function getCustomerComment(): ?string;

    public function setCustomerComment(?string $customerComment): self;

    public function getInformationComment(): ?string;

    public function setInformationComment(?string $informationComment): self;

    public function getInternalComments(): Collection;

    public function setInternalComments(Collection $internalComments): self;

    public function addInternalComment(QuoteInternalComment $comment): void;

    public function hasInternalComment(QuoteInternalComment $quoteComment): bool;

    public function removeInternalComment(QuoteInternalComment $quoteComment): void;

    public function getState(): ?string;

    public function setState(?string $state): self;

    public function getCreatedAt(): ?DateTimeInterface;

    public function setCreatedAt(?DateTimeInterface $createdAt): self;

    public function getUpdatedAt(): ?DateTimeInterface;

    public function setUpdatedAt(?DateTimeInterface $updatedAt): self;

    public function getExpirationDate(): ?DateTimeInterface;

    public function setExpirationDate(?DateTimeInterface $expirationDate): self;

    public function getCountryCode(): ?string;

    public function setCountryCode(?string $countryCode): self;

    public function getLocaleCode(): ?string;

    public function setLocaleCode(?string $localeCode): self;

    public function addItem(QuoteItemInterface $quoteItem): void;

    public function hasItem(QuoteItemInterface $quoteItem): bool;

    public function removeItem(QuoteItemInterface $quoteItem): void;

    public function recalculateTotal(): void;

    public function getItemsTotal(): int;

    public function isEmpty(): bool;
}
